/* 
Fix CDFS.IFS ver 3.0 (c) 2000 by Max Alekseyev <relf@os2.ru>
Support in file/dir names:
- multiple "."
- russian & pseudo letters (1251 codepage) on Joliet FS
*/

Do i=2 to 5; Say SourceLine(i); End; Say

f='cdfs.ifs'
Call CharOut,'Looking for CDFS.IFS... '
if Stream(f,'c','query exists')='' then Say 'Failed!'
Else Do
  Say 'Found!'
  Call Stream f,'c','open'
  sf=Chars(f)
  Call CharOut,' Applying multiple "." fix... '
  p=Pos( X2C('837EF600750C'), CharIn(f,1,sf) )
  If p>0 Then Do
    Call CharOut f, X2C('EB'), p+4  
    Say 'Done!'
  End;Else Do; Say 'Failed!'; End

  Call CharOut,' Looking for Joliet-code signature... '
  p=Pos( X2C('C45E0626803F007525FF46068B5E06268A1F2AFF8A87'), CharIn(f,1,sf) )
  If p>0 Then Do
    Say 'Found!'
    Call CharOut,'  Looking for translation table... '
    t=Pos( D2C(0)||'_______________', CharIn(f,1,sf) )
    if t>0 Then Do
      Say 'Found!'

      Call CharOut,'  Changing translation table... '
      Call CharOut f,,t+128
      Call CharOut f,X2C('5FF0B0B1DAFDF2DFD3BABCBEBD5FD1BF')
      Do i=X2D('80') to X2D('AF'); Call CharOut f,D2C(i); End
      Do i=X2D('E0') to X2D('EF'); Call CharOut f,D2C(i); End
      Call CharOut f,X2C('5FF1C0B3FAFEF3FFFCCACCCECD20D2CF')
      Call CharOut f,Left('',32,'_')
      Say 'Done!'

      Call CharOut,' Applying code fix... '
      t=CharIn(f,p+22,2)
      Call CharOut f,X2C('268A070AC074063C047520B080260A4701BB')||t||X2C('D7'),p+3
      Call CharOut f,X2C('83460602909090909090'),p+30
      Say 'Done!'

    End;Else Do; Say 'Failed!'; End
  End;Else Do; Say 'Failed!'; End
  Call Stream f,'c','close'
End
